varying vec2 texturePos;
varying vec2 positionInFacet;  ///< Ranges from (0, 0) to (1, 1)
uniform sampler2DRect tex;
uniform vec4 blends;
uniform float centerLuminance;
uniform float power;
uniform vec3 gamma;

void main()
{
    vec2 pos = positionInFacet;
	float progress = pos.x < blends[3] ? pos.x / blends[3] : ( // left
		pos.x > 1.0 - blends[1] ? (1.0 - pos.x) / ( blends[1] ) : // right
            1.0
	);
	progress *= pos.y < blends[2] ? pos.y / blends[2] : ( // bottom
		pos.y > 1.0 - blends[0] ? (1.0 - pos.y) / ( blends[0] ) : // top
            1.0
	);
    if ( pos.x < 0.0 || pos.x > 1.0 || pos.y < 0.0 || pos.y > 1.0 )
        discard;
	progress = progress < 0.5 ? centerLuminance * pow(2. * progress, power) : 1.0 - (1.0 - centerLuminance) * pow(2. * (1. - progress), power);

	vec4 result = texture2DRect( tex, texturePos.xy );
	result.r *= pow(progress, 1. / gamma.r);
	result.g *= pow(progress, 1. / gamma.g);
	result.b *= pow(progress, 1. / gamma.b);
	gl_FragColor = result;
}
